#ifndef _SECURE_HASHING_ALGORITHM
#define _SECURE_HASHING_ALGORITHM
/*Secure Hash Algorithm*/
#define CONST_K0_19		0x05A827999
#define CONST_K20_39	0x06ED9EbA1
#define CONST_K40_59	0x08F1BBCDC
#define CONST_K60_79	0x0CA62C1D6

#define CONST_H0	0x067452301
#define CONST_H1	0x0EFCDAB89
#define CONST_H2	0x098BADCFE
#define CONST_H3	0x010325476
#define CONST_H4	0x0C3D2E1F0
#pragma pack(push,1)
typedef struct _SHA1_VAR{
	UINT32 VarH0;
	UINT32 VarH1;	
	UINT32 VarH2;	
	UINT32 VarH3;	
	UINT32 VarH4;	

	UINT32 VarA;
	UINT32 VarB;
	UINT32 VarC;	
	UINT32 VarD;
	UINT32 VarE;

}SHA1_VAR;
#pragma pack(pop)
void Sha1(UINT8 *pMsg, UINT32 MsgLen, UINT32 *pHashOut);
void HashTarget(UINT8 *pMsg, UINT32 MsgLen);
void Sha1Block(UINT8 *pMsg);

//Assembly Helpers
UINT32 F0_19(UINT32 u32Src1, UINT32 u32Src2, UINT32 u32Src3);
UINT32 F20_39(UINT32 u32Src1, UINT32 u32Src2, UINT32 u32Src3);
UINT32 F40_59(UINT32 u32Src1, UINT32 u32Src2, UINT32 u32Src3);
UINT32 F60_79(UINT32 u32Src1, UINT32 u32Src2, UINT32 u32Src3);
#endif //_SECURE_HASHING_ALGORITHM